unit schFacturasProveedorClient_Intf;

interface

uses
  Classes, DB, schBase_Intf, SysUtils, uROClasses, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_FacturasProveedor = '{0EF26853-CA11-423C-A717-4B46C60A1D1B}';
  RID_FacturasProveedor_Detalles = '{55ADC035-4592-4CDA-968B-F19217917CD1}';

  { Data table names }
  nme_FacturasProveedor = 'FacturasProveedor';
  nme_FacturasProveedor_Detalles = 'FacturasProveedor_Detalles';

  { FacturasProveedor fields }
  fld_FacturasProveedorID = 'ID';
  fld_FacturasProveedorID_EMPRESA = 'ID_EMPRESA';
  fld_FacturasProveedorREFERENCIA = 'REFERENCIA';
  fld_FacturasProveedorTIPO = 'TIPO';
  fld_FacturasProveedorREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';
  fld_FacturasProveedorFECHA_FACTURA = 'FECHA_FACTURA';
  fld_FacturasProveedorFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';
  fld_FacturasProveedorSITUACION = 'SITUACION';
  fld_FacturasProveedorBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_FacturasProveedorDESCUENTO = 'DESCUENTO';
  fld_FacturasProveedorIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_FacturasProveedorIVA = 'IVA';
  fld_FacturasProveedorIMPORTE_IVA = 'IMPORTE_IVA';
  fld_FacturasProveedorRE = 'RE';
  fld_FacturasProveedorIMPORTE_RE = 'IMPORTE_RE';
  fld_FacturasProveedorIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasProveedorOBSERVACIONES = 'OBSERVACIONES';
  fld_FacturasProveedorID_PROVEEDOR = 'ID_PROVEEDOR';
  fld_FacturasProveedorNOMBRE_PROVEEDOR = 'NOMBRE_PROVEEDOR';
  fld_FacturasProveedorNOMBRE_COMERCIAL_PROVEEDOR = 'NOMBRE_COMERCIAL_PROVEEDOR';
  fld_FacturasProveedorNIF_CIF = 'NIF_CIF';
  fld_FacturasProveedorNOMBRE = 'NOMBRE';
  fld_FacturasProveedorCALLE = 'CALLE';
  fld_FacturasProveedorPOBLACION = 'POBLACION';
  fld_FacturasProveedorPROVINCIA = 'PROVINCIA';
  fld_FacturasProveedorCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_FacturasProveedorFECHA_ALTA = 'FECHA_ALTA';
  fld_FacturasProveedorFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_FacturasProveedorUSUARIO = 'USUARIO';
  fld_FacturasProveedorID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_FacturasProveedorRECARGO_EQUIVALENCIA = 'RECARGO_EQUIVALENCIA';
  fld_FacturasProveedorID_TIPO_IVA = 'ID_TIPO_IVA';
  fld_FacturasProveedorIMPORTE_NETO = 'IMPORTE_NETO';
  fld_FacturasProveedorIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasProveedorIGNORAR_CONTABILIDAD = 'IGNORAR_CONTABILIDAD';
  fld_FacturasProveedorID_TIENDA = 'ID_TIENDA';
  fld_FacturasProveedorTIENDA = 'TIENDA';
  fld_FacturasProveedorID_SUBCUENTA = 'ID_SUBCUENTA';
  fld_FacturasProveedorSUBCUENTA = 'SUBCUENTA';

  { FacturasProveedor field indexes }
  idx_FacturasProveedorID = 0;
  idx_FacturasProveedorID_EMPRESA = 1;
  idx_FacturasProveedorREFERENCIA = 2;
  idx_FacturasProveedorTIPO = 3;
  idx_FacturasProveedorREFERENCIA_PROVEEDOR = 4;
  idx_FacturasProveedorFECHA_FACTURA = 5;
  idx_FacturasProveedorFECHA_VENCIMIENTO = 6;
  idx_FacturasProveedorSITUACION = 7;
  idx_FacturasProveedorBASE_IMPONIBLE = 8;
  idx_FacturasProveedorDESCUENTO = 9;
  idx_FacturasProveedorIMPORTE_DESCUENTO = 10;
  idx_FacturasProveedorIVA = 11;
  idx_FacturasProveedorIMPORTE_IVA = 12;
  idx_FacturasProveedorRE = 13;
  idx_FacturasProveedorIMPORTE_RE = 14;
  idx_FacturasProveedorIMPORTE_TOTAL = 15;
  idx_FacturasProveedorOBSERVACIONES = 16;
  idx_FacturasProveedorID_PROVEEDOR = 17;
  idx_FacturasProveedorNOMBRE_PROVEEDOR = 18;
  idx_FacturasProveedorNOMBRE_COMERCIAL_PROVEEDOR = 19;
  idx_FacturasProveedorNIF_CIF = 20;
  idx_FacturasProveedorNOMBRE = 21;
  idx_FacturasProveedorCALLE = 22;
  idx_FacturasProveedorPOBLACION = 23;
  idx_FacturasProveedorPROVINCIA = 24;
  idx_FacturasProveedorCODIGO_POSTAL = 25;
  idx_FacturasProveedorFECHA_ALTA = 26;
  idx_FacturasProveedorFECHA_MODIFICACION = 27;
  idx_FacturasProveedorUSUARIO = 28;
  idx_FacturasProveedorID_FORMA_PAGO = 29;
  idx_FacturasProveedorRECARGO_EQUIVALENCIA = 30;
  idx_FacturasProveedorID_TIPO_IVA = 31;
  idx_FacturasProveedorIMPORTE_NETO = 32;
  idx_FacturasProveedorIMPORTE_PORTE = 33;
  idx_FacturasProveedorIGNORAR_CONTABILIDAD = 34;
  idx_FacturasProveedorID_TIENDA = 35;
  idx_FacturasProveedorTIENDA = 36;
  idx_FacturasProveedorID_SUBCUENTA = 37;
  idx_FacturasProveedorSUBCUENTA = 38;

  { FacturasProveedor_Detalles fields }
  fld_FacturasProveedor_DetallesID = 'ID';
  fld_FacturasProveedor_DetallesID_FACTURA = 'ID_FACTURA';
  fld_FacturasProveedor_DetallesPOSICION = 'POSICION';
  fld_FacturasProveedor_DetallesTIPO_DETALLE = 'TIPO_DETALLE';
  fld_FacturasProveedor_DetallesCONCEPTO = 'CONCEPTO';
  fld_FacturasProveedor_DetallesCANTIDAD = 'CANTIDAD';
  fld_FacturasProveedor_DetallesIMPORTE_UNIDAD = 'IMPORTE_UNIDAD';
  fld_FacturasProveedor_DetallesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasProveedor_DetallesVISIBLE = 'VISIBLE';
  fld_FacturasProveedor_DetallesID_ARTICULO = 'ID_ARTICULO';
  fld_FacturasProveedor_DetallesDESCUENTO = 'DESCUENTO';
  fld_FacturasProveedor_DetallesIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasProveedor_DetallesREFERENCIA = 'REFERENCIA';
  fld_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';

  { FacturasProveedor_Detalles field indexes }
  idx_FacturasProveedor_DetallesID = 0;
  idx_FacturasProveedor_DetallesID_FACTURA = 1;
  idx_FacturasProveedor_DetallesPOSICION = 2;
  idx_FacturasProveedor_DetallesTIPO_DETALLE = 3;
  idx_FacturasProveedor_DetallesCONCEPTO = 4;
  idx_FacturasProveedor_DetallesCANTIDAD = 5;
  idx_FacturasProveedor_DetallesIMPORTE_UNIDAD = 6;
  idx_FacturasProveedor_DetallesIMPORTE_TOTAL = 7;
  idx_FacturasProveedor_DetallesVISIBLE = 8;
  idx_FacturasProveedor_DetallesID_ARTICULO = 9;
  idx_FacturasProveedor_DetallesDESCUENTO = 10;
  idx_FacturasProveedor_DetallesIMPORTE_PORTE = 11;
  idx_FacturasProveedor_DetallesREFERENCIA = 12;
  idx_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR = 13;

type
  { IFacturasProveedor }
  IFacturasProveedor = interface(IDAStronglyTypedDataTable)
  ['{83594315-B925-4468-8505-380368A507A6}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetTIPOIsNull: Boolean;
    procedure SetTIPOIsNull(const aValue: Boolean);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORIsNull: Boolean;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetFECHA_FACTURAIsNull: Boolean;
    procedure SetFECHA_FACTURAIsNull(const aValue: Boolean);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
    function GetFECHA_VENCIMIENTOIsNull: Boolean;
    procedure SetFECHA_VENCIMIENTOIsNull(const aValue: Boolean);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetSITUACIONIsNull: Boolean;
    procedure SetSITUACIONIsNull(const aValue: Boolean);
    function GetBASE_IMPONIBLEValue: Currency;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency);
    function GetBASE_IMPONIBLEIsNull: Boolean;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetDESCUENTOIsNull: Boolean;
    procedure SetDESCUENTOIsNull(const aValue: Boolean);
    function GetIMPORTE_DESCUENTOValue: Currency;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency);
    function GetIMPORTE_DESCUENTOIsNull: Boolean;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIVAIsNull: Boolean;
    procedure SetIVAIsNull(const aValue: Boolean);
    function GetIMPORTE_IVAValue: Currency;
    procedure SetIMPORTE_IVAValue(const aValue: Currency);
    function GetIMPORTE_IVAIsNull: Boolean;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean);
    function GetREValue: Float;
    procedure SetREValue(const aValue: Float);
    function GetREIsNull: Boolean;
    procedure SetREIsNull(const aValue: Boolean);
    function GetIMPORTE_REValue: Currency;
    procedure SetIMPORTE_REValue(const aValue: Currency);
    function GetIMPORTE_REIsNull: Boolean;
    procedure SetIMPORTE_REIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetOBSERVACIONESValue: IROStrings;
    function GetOBSERVACIONESIsNull: Boolean;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean);
    function GetID_PROVEEDORValue: Integer;
    procedure SetID_PROVEEDORValue(const aValue: Integer);
    function GetID_PROVEEDORIsNull: Boolean;
    procedure SetID_PROVEEDORIsNull(const aValue: Boolean);
    function GetNOMBRE_PROVEEDORValue: String;
    procedure SetNOMBRE_PROVEEDORValue(const aValue: String);
    function GetNOMBRE_PROVEEDORIsNull: Boolean;
    procedure SetNOMBRE_PROVEEDORIsNull(const aValue: Boolean);
    function GetNOMBRE_COMERCIAL_PROVEEDORValue: String;
    procedure SetNOMBRE_COMERCIAL_PROVEEDORValue(const aValue: String);
    function GetNOMBRE_COMERCIAL_PROVEEDORIsNull: Boolean;
    procedure SetNOMBRE_COMERCIAL_PROVEEDORIsNull(const aValue: Boolean);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNIF_CIFIsNull: Boolean;
    procedure SetNIF_CIFIsNull(const aValue: Boolean);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetNOMBREIsNull: Boolean;
    procedure SetNOMBREIsNull(const aValue: Boolean);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetCALLEIsNull: Boolean;
    procedure SetCALLEIsNull(const aValue: Boolean);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPOBLACIONIsNull: Boolean;
    procedure SetPOBLACIONIsNull(const aValue: Boolean);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetPROVINCIAIsNull: Boolean;
    procedure SetPROVINCIAIsNull(const aValue: Boolean);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetCODIGO_POSTALIsNull: Boolean;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_ALTAIsNull: Boolean;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONIsNull: Boolean;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetUSUARIOIsNull: Boolean;
    procedure SetUSUARIOIsNull(const aValue: Boolean);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetID_FORMA_PAGOIsNull: Boolean;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean);
    function GetRECARGO_EQUIVALENCIAValue: SmallInt;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: SmallInt);
    function GetRECARGO_EQUIVALENCIAIsNull: Boolean;
    procedure SetRECARGO_EQUIVALENCIAIsNull(const aValue: Boolean);
    function GetID_TIPO_IVAValue: Integer;
    procedure SetID_TIPO_IVAValue(const aValue: Integer);
    function GetID_TIPO_IVAIsNull: Boolean;
    procedure SetID_TIPO_IVAIsNull(const aValue: Boolean);
    function GetIMPORTE_NETOValue: Currency;
    procedure SetIMPORTE_NETOValue(const aValue: Currency);
    function GetIMPORTE_NETOIsNull: Boolean;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetIMPORTE_PORTEIsNull: Boolean;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean);
    function GetIGNORAR_CONTABILIDADValue: SmallInt;
    procedure SetIGNORAR_CONTABILIDADValue(const aValue: SmallInt);
    function GetIGNORAR_CONTABILIDADIsNull: Boolean;
    procedure SetIGNORAR_CONTABILIDADIsNull(const aValue: Boolean);
    function GetID_TIENDAValue: Integer;
    procedure SetID_TIENDAValue(const aValue: Integer);
    function GetID_TIENDAIsNull: Boolean;
    procedure SetID_TIENDAIsNull(const aValue: Boolean);
    function GetTIENDAValue: String;
    procedure SetTIENDAValue(const aValue: String);
    function GetTIENDAIsNull: Boolean;
    procedure SetTIENDAIsNull(const aValue: Boolean);
    function GetID_SUBCUENTAValue: Integer;
    procedure SetID_SUBCUENTAValue(const aValue: Integer);
    function GetID_SUBCUENTAIsNull: Boolean;
    procedure SetID_SUBCUENTAIsNull(const aValue: Boolean);
    function GetSUBCUENTAValue: String;
    procedure SetSUBCUENTAValue(const aValue: String);
    function GetSUBCUENTAIsNull: Boolean;
    procedure SetSUBCUENTAIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FECHA_FACTURAIsNull: Boolean read GetFECHA_FACTURAIsNull write SetFECHA_FACTURAIsNull;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property FECHA_VENCIMIENTOIsNull: Boolean read GetFECHA_VENCIMIENTOIsNull write SetFECHA_VENCIMIENTOIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property RE: Float read GetREValue write SetREValue;
    property REIsNull: Boolean read GetREIsNull write SetREIsNull;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_REIsNull: Boolean read GetIMPORTE_REIsNull write SetIMPORTE_REIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property ID_PROVEEDORIsNull: Boolean read GetID_PROVEEDORIsNull write SetID_PROVEEDORIsNull;
    property NOMBRE_PROVEEDOR: String read GetNOMBRE_PROVEEDORValue write SetNOMBRE_PROVEEDORValue;
    property NOMBRE_PROVEEDORIsNull: Boolean read GetNOMBRE_PROVEEDORIsNull write SetNOMBRE_PROVEEDORIsNull;
    property NOMBRE_COMERCIAL_PROVEEDOR: String read GetNOMBRE_COMERCIAL_PROVEEDORValue write SetNOMBRE_COMERCIAL_PROVEEDORValue;
    property NOMBRE_COMERCIAL_PROVEEDORIsNull: Boolean read GetNOMBRE_COMERCIAL_PROVEEDORIsNull write SetNOMBRE_COMERCIAL_PROVEEDORIsNull;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NIF_CIFIsNull: Boolean read GetNIF_CIFIsNull write SetNIF_CIFIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property RECARGO_EQUIVALENCIA: SmallInt read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property RECARGO_EQUIVALENCIAIsNull: Boolean read GetRECARGO_EQUIVALENCIAIsNull write SetRECARGO_EQUIVALENCIAIsNull;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property ID_TIPO_IVAIsNull: Boolean read GetID_TIPO_IVAIsNull write SetID_TIPO_IVAIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property IGNORAR_CONTABILIDAD: SmallInt read GetIGNORAR_CONTABILIDADValue write SetIGNORAR_CONTABILIDADValue;
    property IGNORAR_CONTABILIDADIsNull: Boolean read GetIGNORAR_CONTABILIDADIsNull write SetIGNORAR_CONTABILIDADIsNull;
    property ID_TIENDA: Integer read GetID_TIENDAValue write SetID_TIENDAValue;
    property ID_TIENDAIsNull: Boolean read GetID_TIENDAIsNull write SetID_TIENDAIsNull;
    property TIENDA: String read GetTIENDAValue write SetTIENDAValue;
    property TIENDAIsNull: Boolean read GetTIENDAIsNull write SetTIENDAIsNull;
    property ID_SUBCUENTA: Integer read GetID_SUBCUENTAValue write SetID_SUBCUENTAValue;
    property ID_SUBCUENTAIsNull: Boolean read GetID_SUBCUENTAIsNull write SetID_SUBCUENTAIsNull;
    property SUBCUENTA: String read GetSUBCUENTAValue write SetSUBCUENTAValue;
    property SUBCUENTAIsNull: Boolean read GetSUBCUENTAIsNull write SetSUBCUENTAIsNull;
  end;

  { TFacturasProveedorDataTableRules }
  TFacturasProveedorDataTableRules = class(TIntfObjectDADataTableRules, IFacturasProveedor)
  private
    f_OBSERVACIONES: IROStrings;
    procedure OBSERVACIONES_OnChange(Sender: TObject);
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetTIPOIsNull: Boolean; virtual;
    procedure SetTIPOIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORIsNull: Boolean; virtual;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetFECHA_FACTURAIsNull: Boolean; virtual;
    procedure SetFECHA_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;
    function GetFECHA_VENCIMIENTOIsNull: Boolean; virtual;
    procedure SetFECHA_VENCIMIENTOIsNull(const aValue: Boolean); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetSITUACIONIsNull: Boolean; virtual;
    procedure SetSITUACIONIsNull(const aValue: Boolean); virtual;
    function GetBASE_IMPONIBLEValue: Currency; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency); virtual;
    function GetBASE_IMPONIBLEIsNull: Boolean; virtual;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetDESCUENTOIsNull: Boolean; virtual;
    procedure SetDESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_DESCUENTOValue: Currency; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency); virtual;
    function GetIMPORTE_DESCUENTOIsNull: Boolean; virtual;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIVAIsNull: Boolean; virtual;
    procedure SetIVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_IVAValue: Currency; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Currency); virtual;
    function GetIMPORTE_IVAIsNull: Boolean; virtual;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean); virtual;
    function GetREValue: Float; virtual;
    procedure SetREValue(const aValue: Float); virtual;
    function GetREIsNull: Boolean; virtual;
    procedure SetREIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_REValue: Currency; virtual;
    procedure SetIMPORTE_REValue(const aValue: Currency); virtual;
    function GetIMPORTE_REIsNull: Boolean; virtual;
    procedure SetIMPORTE_REIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    function GetOBSERVACIONESIsNull: Boolean; virtual;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetID_PROVEEDORIsNull: Boolean; virtual;
    procedure SetID_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetNOMBRE_PROVEEDORValue: String; virtual;
    procedure SetNOMBRE_PROVEEDORValue(const aValue: String); virtual;
    function GetNOMBRE_PROVEEDORIsNull: Boolean; virtual;
    procedure SetNOMBRE_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetNOMBRE_COMERCIAL_PROVEEDORValue: String; virtual;
    procedure SetNOMBRE_COMERCIAL_PROVEEDORValue(const aValue: String); virtual;
    function GetNOMBRE_COMERCIAL_PROVEEDORIsNull: Boolean; virtual;
    procedure SetNOMBRE_COMERCIAL_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNIF_CIFIsNull: Boolean; virtual;
    procedure SetNIF_CIFIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetCALLEIsNull: Boolean; virtual;
    procedure SetCALLEIsNull(const aValue: Boolean); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPOBLACIONIsNull: Boolean; virtual;
    procedure SetPOBLACIONIsNull(const aValue: Boolean); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetPROVINCIAIsNull: Boolean; virtual;
    procedure SetPROVINCIAIsNull(const aValue: Boolean); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetCODIGO_POSTALIsNull: Boolean; virtual;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_ALTAIsNull: Boolean; virtual;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONIsNull: Boolean; virtual;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetUSUARIOIsNull: Boolean; virtual;
    procedure SetUSUARIOIsNull(const aValue: Boolean); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetID_FORMA_PAGOIsNull: Boolean; virtual;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean); virtual;
    function GetRECARGO_EQUIVALENCIAValue: SmallInt; virtual;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: SmallInt); virtual;
    function GetRECARGO_EQUIVALENCIAIsNull: Boolean; virtual;
    procedure SetRECARGO_EQUIVALENCIAIsNull(const aValue: Boolean); virtual;
    function GetID_TIPO_IVAValue: Integer; virtual;
    procedure SetID_TIPO_IVAValue(const aValue: Integer); virtual;
    function GetID_TIPO_IVAIsNull: Boolean; virtual;
    procedure SetID_TIPO_IVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_NETOValue: Currency; virtual;
    procedure SetIMPORTE_NETOValue(const aValue: Currency); virtual;
    function GetIMPORTE_NETOIsNull: Boolean; virtual;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEIsNull: Boolean; virtual;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean); virtual;
    function GetIGNORAR_CONTABILIDADValue: SmallInt; virtual;
    procedure SetIGNORAR_CONTABILIDADValue(const aValue: SmallInt); virtual;
    function GetIGNORAR_CONTABILIDADIsNull: Boolean; virtual;
    procedure SetIGNORAR_CONTABILIDADIsNull(const aValue: Boolean); virtual;
    function GetID_TIENDAValue: Integer; virtual;
    procedure SetID_TIENDAValue(const aValue: Integer); virtual;
    function GetID_TIENDAIsNull: Boolean; virtual;
    procedure SetID_TIENDAIsNull(const aValue: Boolean); virtual;
    function GetTIENDAValue: String; virtual;
    procedure SetTIENDAValue(const aValue: String); virtual;
    function GetTIENDAIsNull: Boolean; virtual;
    procedure SetTIENDAIsNull(const aValue: Boolean); virtual;
    function GetID_SUBCUENTAValue: Integer; virtual;
    procedure SetID_SUBCUENTAValue(const aValue: Integer); virtual;
    function GetID_SUBCUENTAIsNull: Boolean; virtual;
    procedure SetID_SUBCUENTAIsNull(const aValue: Boolean); virtual;
    function GetSUBCUENTAValue: String; virtual;
    procedure SetSUBCUENTAValue(const aValue: String); virtual;
    function GetSUBCUENTAIsNull: Boolean; virtual;
    procedure SetSUBCUENTAIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FECHA_FACTURAIsNull: Boolean read GetFECHA_FACTURAIsNull write SetFECHA_FACTURAIsNull;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
    property FECHA_VENCIMIENTOIsNull: Boolean read GetFECHA_VENCIMIENTOIsNull write SetFECHA_VENCIMIENTOIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property RE: Float read GetREValue write SetREValue;
    property REIsNull: Boolean read GetREIsNull write SetREIsNull;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_REIsNull: Boolean read GetIMPORTE_REIsNull write SetIMPORTE_REIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property ID_PROVEEDORIsNull: Boolean read GetID_PROVEEDORIsNull write SetID_PROVEEDORIsNull;
    property NOMBRE_PROVEEDOR: String read GetNOMBRE_PROVEEDORValue write SetNOMBRE_PROVEEDORValue;
    property NOMBRE_PROVEEDORIsNull: Boolean read GetNOMBRE_PROVEEDORIsNull write SetNOMBRE_PROVEEDORIsNull;
    property NOMBRE_COMERCIAL_PROVEEDOR: String read GetNOMBRE_COMERCIAL_PROVEEDORValue write SetNOMBRE_COMERCIAL_PROVEEDORValue;
    property NOMBRE_COMERCIAL_PROVEEDORIsNull: Boolean read GetNOMBRE_COMERCIAL_PROVEEDORIsNull write SetNOMBRE_COMERCIAL_PROVEEDORIsNull;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NIF_CIFIsNull: Boolean read GetNIF_CIFIsNull write SetNIF_CIFIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property RECARGO_EQUIVALENCIA: SmallInt read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property RECARGO_EQUIVALENCIAIsNull: Boolean read GetRECARGO_EQUIVALENCIAIsNull write SetRECARGO_EQUIVALENCIAIsNull;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property ID_TIPO_IVAIsNull: Boolean read GetID_TIPO_IVAIsNull write SetID_TIPO_IVAIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property IGNORAR_CONTABILIDAD: SmallInt read GetIGNORAR_CONTABILIDADValue write SetIGNORAR_CONTABILIDADValue;
    property IGNORAR_CONTABILIDADIsNull: Boolean read GetIGNORAR_CONTABILIDADIsNull write SetIGNORAR_CONTABILIDADIsNull;
    property ID_TIENDA: Integer read GetID_TIENDAValue write SetID_TIENDAValue;
    property ID_TIENDAIsNull: Boolean read GetID_TIENDAIsNull write SetID_TIENDAIsNull;
    property TIENDA: String read GetTIENDAValue write SetTIENDAValue;
    property TIENDAIsNull: Boolean read GetTIENDAIsNull write SetTIENDAIsNull;
    property ID_SUBCUENTA: Integer read GetID_SUBCUENTAValue write SetID_SUBCUENTAValue;
    property ID_SUBCUENTAIsNull: Boolean read GetID_SUBCUENTAIsNull write SetID_SUBCUENTAIsNull;
    property SUBCUENTA: String read GetSUBCUENTAValue write SetSUBCUENTAValue;
    property SUBCUENTAIsNull: Boolean read GetSUBCUENTAIsNull write SetSUBCUENTAIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasProveedor_Detalles }
  IFacturasProveedor_Detalles = interface(IDAStronglyTypedDataTable)
  ['{D0DDC85A-B7D6-4471-8F74-08884C18C78C}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_FACTURAIsNull: Boolean;
    procedure SetID_FACTURAIsNull(const aValue: Boolean);
    function GetPOSICIONValue: Integer;
    procedure SetPOSICIONValue(const aValue: Integer);
    function GetPOSICIONIsNull: Boolean;
    procedure SetPOSICIONIsNull(const aValue: Boolean);
    function GetTIPO_DETALLEValue: String;
    procedure SetTIPO_DETALLEValue(const aValue: String);
    function GetTIPO_DETALLEIsNull: Boolean;
    procedure SetTIPO_DETALLEIsNull(const aValue: Boolean);
    function GetCONCEPTOValue: String;
    procedure SetCONCEPTOValue(const aValue: String);
    function GetCONCEPTOIsNull: Boolean;
    procedure SetCONCEPTOIsNull(const aValue: Boolean);
    function GetCANTIDADValue: Integer;
    procedure SetCANTIDADValue(const aValue: Integer);
    function GetCANTIDADIsNull: Boolean;
    procedure SetCANTIDADIsNull(const aValue: Boolean);
    function GetIMPORTE_UNIDADValue: Currency;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency);
    function GetIMPORTE_UNIDADIsNull: Boolean;
    procedure SetIMPORTE_UNIDADIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetVISIBLEValue: SmallInt;
    procedure SetVISIBLEValue(const aValue: SmallInt);
    function GetVISIBLEIsNull: Boolean;
    procedure SetVISIBLEIsNull(const aValue: Boolean);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetID_ARTICULOIsNull: Boolean;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetDESCUENTOIsNull: Boolean;
    procedure SetDESCUENTOIsNull(const aValue: Boolean);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetIMPORTE_PORTEIsNull: Boolean;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORIsNull: Boolean;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property POSICIONIsNull: Boolean read GetPOSICIONIsNull write SetPOSICIONIsNull;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property TIPO_DETALLEIsNull: Boolean read GetTIPO_DETALLEIsNull write SetTIPO_DETALLEIsNull;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CONCEPTOIsNull: Boolean read GetCONCEPTOIsNull write SetCONCEPTOIsNull;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_UNIDADIsNull: Boolean read GetIMPORTE_UNIDADIsNull write SetIMPORTE_UNIDADIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property VISIBLE: SmallInt read GetVISIBLEValue write SetVISIBLEValue;
    property VISIBLEIsNull: Boolean read GetVISIBLEIsNull write SetVISIBLEIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
  end;

  { TFacturasProveedor_DetallesDataTableRules }
  TFacturasProveedor_DetallesDataTableRules = class(TIntfObjectDADataTableRules, IFacturasProveedor_Detalles)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_FACTURAIsNull: Boolean; virtual;
    procedure SetID_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetPOSICIONIsNull: Boolean; virtual;
    procedure SetPOSICIONIsNull(const aValue: Boolean); virtual;
    function GetTIPO_DETALLEValue: String; virtual;
    procedure SetTIPO_DETALLEValue(const aValue: String); virtual;
    function GetTIPO_DETALLEIsNull: Boolean; virtual;
    procedure SetTIPO_DETALLEIsNull(const aValue: Boolean); virtual;
    function GetCONCEPTOValue: String; virtual;
    procedure SetCONCEPTOValue(const aValue: String); virtual;
    function GetCONCEPTOIsNull: Boolean; virtual;
    procedure SetCONCEPTOIsNull(const aValue: Boolean); virtual;
    function GetCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetCANTIDADIsNull: Boolean; virtual;
    procedure SetCANTIDADIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_UNIDADValue: Currency; virtual;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency); virtual;
    function GetIMPORTE_UNIDADIsNull: Boolean; virtual;
    procedure SetIMPORTE_UNIDADIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetVISIBLEValue: SmallInt; virtual;
    procedure SetVISIBLEValue(const aValue: SmallInt); virtual;
    function GetVISIBLEIsNull: Boolean; virtual;
    procedure SetVISIBLEIsNull(const aValue: Boolean); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetID_ARTICULOIsNull: Boolean; virtual;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetDESCUENTOIsNull: Boolean; virtual;
    procedure SetDESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEIsNull: Boolean; virtual;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORIsNull: Boolean; virtual;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property POSICIONIsNull: Boolean read GetPOSICIONIsNull write SetPOSICIONIsNull;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property TIPO_DETALLEIsNull: Boolean read GetTIPO_DETALLEIsNull write SetTIPO_DETALLEIsNull;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CONCEPTOIsNull: Boolean read GetCONCEPTOIsNull write SetCONCEPTOIsNull;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_UNIDADIsNull: Boolean read GetIMPORTE_UNIDADIsNull write SetIMPORTE_UNIDADIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property VISIBLE: SmallInt read GetVISIBLEValue write SetVISIBLEValue;
    property VISIBLEIsNull: Boolean read GetVISIBLEIsNull write SetVISIBLEIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ TFacturasProveedorDataTableRules }
constructor TFacturasProveedorDataTableRules.Create(aDataTable: TDADataTable);
var
  StrList: TStringList;
begin
  inherited;

  StrList := TStringList.Create;
  StrList.OnChange := OBSERVACIONES_OnChange;
  f_OBSERVACIONES := NewROStrings(StrList,True);
end;

destructor TFacturasProveedorDataTableRules.Destroy;
begin
  inherited;
end;

procedure TFacturasProveedorDataTableRules.OBSERVACIONES_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_FacturasProveedorOBSERVACIONES].AsVariant := TStringList(Sender).Text;
end;

function TFacturasProveedorDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorID].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorID].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_EMPRESA].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_EMPRESA].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_EMPRESA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorID_EMPRESA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorREFERENCIA].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorREFERENCIA].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorREFERENCIA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorREFERENCIA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorTIPO].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorTIPO].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetTIPOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorTIPO].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetTIPOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorTIPO].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorREFERENCIA_PROVEEDOR].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetREFERENCIA_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorREFERENCIA_PROVEEDOR].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorREFERENCIA_PROVEEDOR].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_FACTURA].AsDateTime;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedorFECHA_FACTURA].AsDateTime := aValue;
end;

function TFacturasProveedorDataTableRules.GetFECHA_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_FACTURA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorFECHA_FACTURA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedorFECHA_VENCIMIENTO].AsDateTime := aValue;
end;

function TFacturasProveedorDataTableRules.GetFECHA_VENCIMIENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_VENCIMIENTO].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_VENCIMIENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorFECHA_VENCIMIENTO].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorSITUACION].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorSITUACION].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetSITUACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorSITUACION].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetSITUACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorSITUACION].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetBASE_IMPONIBLEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorBASE_IMPONIBLE].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorBASE_IMPONIBLE].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetBASE_IMPONIBLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorBASE_IMPONIBLE].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorBASE_IMPONIBLE].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedorDESCUENTO].AsFloat;
end;

procedure TFacturasProveedorDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedorDESCUENTO].AsFloat := aValue;
end;

function TFacturasProveedorDataTableRules.GetDESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorDESCUENTO].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetDESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorDESCUENTO].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_DESCUENTOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_DESCUENTO].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_DESCUENTO].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_DESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_DESCUENTO].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorIMPORTE_DESCUENTO].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedorIVA].AsFloat;
end;

procedure TFacturasProveedorDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedorIVA].AsFloat := aValue;
end;

function TFacturasProveedorDataTableRules.GetIVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorIVA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetIVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorIVA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_IVAValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_IVA].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_IVAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_IVA].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_IVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_IVA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorIMPORTE_IVA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetREValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedorRE].AsFloat;
end;

procedure TFacturasProveedorDataTableRules.SetREValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedorRE].AsFloat := aValue;
end;

function TFacturasProveedorDataTableRules.GetREIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorRE].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorRE].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_REValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_RE].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_REValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_RE].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_REIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_RE].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_REIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorIMPORTE_RE].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_TOTAL].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorIMPORTE_TOTAL].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := f_OBSERVACIONES;
  result.Text := DataTable.Fields[idx_FacturasProveedorOBSERVACIONES].AsString;
end;

function TFacturasProveedorDataTableRules.GetOBSERVACIONESIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorOBSERVACIONES].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetOBSERVACIONESIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorOBSERVACIONES].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetID_PROVEEDORValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_PROVEEDOR].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_PROVEEDOR].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetID_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_PROVEEDOR].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetID_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorID_PROVEEDOR].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetNOMBRE_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorNOMBRE_PROVEEDOR].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetNOMBRE_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorNOMBRE_PROVEEDOR].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetNOMBRE_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorNOMBRE_PROVEEDOR].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetNOMBRE_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorNOMBRE_PROVEEDOR].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetNOMBRE_COMERCIAL_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorNOMBRE_COMERCIAL_PROVEEDOR].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetNOMBRE_COMERCIAL_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorNOMBRE_COMERCIAL_PROVEEDOR].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetNOMBRE_COMERCIAL_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorNOMBRE_COMERCIAL_PROVEEDOR].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetNOMBRE_COMERCIAL_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorNOMBRE_COMERCIAL_PROVEEDOR].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorNIF_CIF].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorNIF_CIF].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetNIF_CIFIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorNIF_CIF].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetNIF_CIFIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorNIF_CIF].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorNOMBRE].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorNOMBRE].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetNOMBREIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorNOMBRE].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorNOMBRE].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorCALLE].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorCALLE].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetCALLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorCALLE].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetCALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorCALLE].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorPOBLACION].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorPOBLACION].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetPOBLACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorPOBLACION].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetPOBLACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorPOBLACION].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorPROVINCIA].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorPROVINCIA].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetPROVINCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorPROVINCIA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetPROVINCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorPROVINCIA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorCODIGO_POSTAL].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorCODIGO_POSTAL].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetCODIGO_POSTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorCODIGO_POSTAL].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetCODIGO_POSTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorCODIGO_POSTAL].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_ALTA].AsDateTime;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedorFECHA_ALTA].AsDateTime := aValue;
end;

function TFacturasProveedorDataTableRules.GetFECHA_ALTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_ALTA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_ALTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorFECHA_ALTA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_MODIFICACION].AsDateTime;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedorFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TFacturasProveedorDataTableRules.GetFECHA_MODIFICACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_MODIFICACION].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorFECHA_MODIFICACION].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorUSUARIO].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorUSUARIO].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetUSUARIOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorUSUARIO].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetUSUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorUSUARIO].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_FORMA_PAGO].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_FORMA_PAGO].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetID_FORMA_PAGOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_FORMA_PAGO].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetID_FORMA_PAGOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorID_FORMA_PAGO].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetRECARGO_EQUIVALENCIAValue: SmallInt;
begin
  result := DataTable.Fields[idx_FacturasProveedorRECARGO_EQUIVALENCIA].AsSmallInt;
end;

procedure TFacturasProveedorDataTableRules.SetRECARGO_EQUIVALENCIAValue(const aValue: SmallInt);
begin
  DataTable.Fields[idx_FacturasProveedorRECARGO_EQUIVALENCIA].AsSmallInt := aValue;
end;

function TFacturasProveedorDataTableRules.GetRECARGO_EQUIVALENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorRECARGO_EQUIVALENCIA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetRECARGO_EQUIVALENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorRECARGO_EQUIVALENCIA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetID_TIPO_IVAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_TIPO_IVA].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_TIPO_IVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_TIPO_IVA].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetID_TIPO_IVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_TIPO_IVA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetID_TIPO_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorID_TIPO_IVA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_NETO].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_NETO].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_NETOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_NETO].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_NETOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorIMPORTE_NETO].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_PORTE].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_PORTE].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_PORTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_PORTE].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_PORTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorIMPORTE_PORTE].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetIGNORAR_CONTABILIDADValue: SmallInt;
begin
  result := DataTable.Fields[idx_FacturasProveedorIGNORAR_CONTABILIDAD].AsSmallInt;
end;

procedure TFacturasProveedorDataTableRules.SetIGNORAR_CONTABILIDADValue(const aValue: SmallInt);
begin
  DataTable.Fields[idx_FacturasProveedorIGNORAR_CONTABILIDAD].AsSmallInt := aValue;
end;

function TFacturasProveedorDataTableRules.GetIGNORAR_CONTABILIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorIGNORAR_CONTABILIDAD].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetIGNORAR_CONTABILIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorIGNORAR_CONTABILIDAD].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetID_TIENDAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_TIENDA].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_TIENDAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_TIENDA].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetID_TIENDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_TIENDA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetID_TIENDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorID_TIENDA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetTIENDAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorTIENDA].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetTIENDAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorTIENDA].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetTIENDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorTIENDA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetTIENDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorTIENDA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetID_SUBCUENTAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_SUBCUENTA].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_SUBCUENTAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_SUBCUENTA].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetID_SUBCUENTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_SUBCUENTA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetID_SUBCUENTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorID_SUBCUENTA].AsVariant := Null;
end;

function TFacturasProveedorDataTableRules.GetSUBCUENTAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorSUBCUENTA].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetSUBCUENTAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorSUBCUENTA].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetSUBCUENTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedorSUBCUENTA].IsNull;
end;

procedure TFacturasProveedorDataTableRules.SetSUBCUENTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedorSUBCUENTA].AsVariant := Null;
end;


{ TFacturasProveedor_DetallesDataTableRules }
constructor TFacturasProveedor_DetallesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasProveedor_DetallesDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesID].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesID].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesID].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesID].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesID_FACTURA].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesID_FACTURA].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetID_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesID_FACTURA].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetID_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesID_FACTURA].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetPOSICIONValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesPOSICION].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetPOSICIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesPOSICION].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetPOSICIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesPOSICION].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetPOSICIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesPOSICION].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetTIPO_DETALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesTIPO_DETALLE].AsString;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetTIPO_DETALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesTIPO_DETALLE].AsString := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetTIPO_DETALLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesTIPO_DETALLE].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetTIPO_DETALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesTIPO_DETALLE].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetCONCEPTOValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesCONCEPTO].AsString;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetCONCEPTOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesCONCEPTO].AsString := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetCONCEPTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesCONCEPTO].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetCONCEPTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesCONCEPTO].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetCANTIDADValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesCANTIDAD].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetCANTIDADValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesCANTIDAD].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetCANTIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesCANTIDAD].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetCANTIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesCANTIDAD].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIMPORTE_UNIDADValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_UNIDAD].AsCurrency;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIMPORTE_UNIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_UNIDAD].AsCurrency := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIMPORTE_UNIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_UNIDAD].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIMPORTE_UNIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_UNIDAD].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_TOTAL].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_TOTAL].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetVISIBLEValue: SmallInt;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesVISIBLE].AsSmallInt;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetVISIBLEValue(const aValue: SmallInt);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesVISIBLE].AsSmallInt := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetVISIBLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesVISIBLE].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetVISIBLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesVISIBLE].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesID_ARTICULO].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesID_ARTICULO].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetID_ARTICULOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesID_ARTICULO].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetID_ARTICULOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesID_ARTICULO].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesDESCUENTO].AsFloat;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesDESCUENTO].AsFloat := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetDESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesDESCUENTO].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetDESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesDESCUENTO].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_PORTE].AsCurrency;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_PORTE].AsCurrency := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIMPORTE_PORTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_PORTE].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIMPORTE_PORTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_PORTE].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA].AsString;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA].AsString := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA].AsVariant := Null;
end;

function TFacturasProveedor_DetallesDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR].AsString;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetREFERENCIA_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR].IsNull;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID_FacturasProveedor, TFacturasProveedorDataTableRules);
  RegisterDataTableRules(RID_FacturasProveedor_Detalles, TFacturasProveedor_DetallesDataTableRules);

end.
